package vehicle;

public class Vehicle extends Driver{   //Class Vehicle that inherits from Driver class

	    private static int maxVIN;         //Class variable
	    private int vin;                   //Object owned by variable
	    private double currentSpeed;
	    private String currentDirection;
	    private String ownerName;

	    public Vehicle() {   //constructor with no parameters

	    	super("Tom Grant");
	    	vin=0;
	    	maxVIN = 0;
	    	currentSpeed=0;
	    	currentDirection="";
	    	ownerName = "None";
	    }
	    
	    public Vehicle(String ownNm) {     //constructor with 1 parameters

	    	super("Mike Skywalker");
	    	ownerName= ownNm;
	    	vin=0;
	    	maxVIN = 0;
	    	currentSpeed=0;
	    	currentDirection="";
	    	
	    }
	    
	    public void setVehicleSpeed(double currentSpeed) {  //set the current speed
	  	  
	    	this.currentSpeed = currentSpeed;
		}
	    
	    public double getVehicleSpeed(){   //return the current speed
		    
		      return currentSpeed;
		}
	    
	    public void setVehicleDirection(String currentDirection) {  //set the current direction
		  	  
	    	this.currentDirection = currentDirection;
		}
	    
	    public String getVehicleDirection(){   //return the current direction
		    
		      return currentDirection;
		}

	    public void setVIN(int vin1) {   //set each vehicle's VIN 

	    	if(vin1 > maxVIN){           //look for, and set, the max VIN 
	    		maxVIN = vin1;
	    	}
	    	vin = vin1;
	    }
	    
	    public int getVIN() {    //return each vehicle's vin
	    	
	    	  return vin;
	    }
	    
	    public int getMaxVIN(){  //get the value of the class variable for all objects
	    	return maxVIN;
	    }
	     
	    public String toString() {          //Cast the Vehicle to a string and output the values

	    	if(!ownerName.equalsIgnoreCase("")){
	    		return "Vehicle owner: " + ownerName + ", VIN: " + vin + ", current speed: " + currentSpeed + ", Current Direction: " + currentDirection;   //Output if model, and year are passed to constructor
	    	}
	    	else{
	    		return "Vehicle owner: " + ownerName + ", VIN: " + vin + ", current speed: " + currentSpeed + ", Current Direction: " + currentDirection;  //Output if make, model, and year are passed to constructor
	    	}
	    }
		
		public static void main(String[] args) {
			
			Vehicle vehicle1 = new  Vehicle("Tom Burger");  //Instantiate Vehicle class pass in the string
			Vehicle vehicle2 = new  Vehicle("John Rider");
			Vehicle vehicle3 = new  Vehicle("Pete Bucks");
			
			String driverName1 = vehicle1.getName();   //Call getname on vehicle objects, inherited from Driver class
			String driverName2 = vehicle2.getName();
			String driverName3 = vehicle3.getName();
			
			vehicle1.setVIN(1177523);               //On each vehicle object, call setVIN, set vehicle speed and vehicle direc
			vehicle1.setVehicleSpeed(65.00);
			vehicle1.setVehicleDirection("North");
			System.out.println(vehicle1.toString());
			
			vehicle2.setVIN(223250000);
			vehicle2.setVehicleSpeed(40.00);
			vehicle2.setVehicleDirection("West");
			System.out.println(vehicle2.toString());
			
			vehicle3.setVIN(94525870);
			vehicle3.setVehicleSpeed(55.00);
			vehicle3.setVehicleDirection("South");
			System.out.println(vehicle3.toString());
			
			System.out.println("The max VIN is: " + vehicle1.getMaxVIN() + " the test driver name is: " + driverName1); //output the max VIN for the objects and the driver name.
			System.out.println("The max VIN is: " + vehicle2.getMaxVIN() + " the test driver name is: " + driverName1);
			System.out.println("The max VIN is: " + vehicle3.getMaxVIN() + " the test driver name is: " + driverName1);
			
		}
	
	
}
